package org.jwat.tools.test;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.List;

import org.jwat.tools.core.ArrayUtils;

public class TestArraySearch {

	public static final byte[] HTTPSLASH_BYTES = "HTTP/".getBytes();
	public static final byte[] LF_BYTES = "\n".getBytes();
	public static final byte[] LFLF_BYTES = "\n\n".getBytes();
	public static final byte[] CRLF_BYTES = "\r\n".getBytes();
	public static final byte[] CRLFCRLF_BYTES = "\r\n\r\n".getBytes();

	public static void main(String[] args) {
		byte[] data;
		File wrongFile = new File("/home/nicl/", "wrong-250.txt");
		RandomAccessFile ram;
		try {
			ram = new RandomAccessFile(wrongFile, "r");
			data = new byte[(int)ram.length()];
			ram.readFully(data);
			ram.close();

            int fIdx;
            int lIdx;

            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            List<byte[]> lines = null;
            String line;
            String[] statusParts;
            StringBuilder sb = new StringBuilder();

            if (ArrayUtils.startsWith(HTTPSLASH_BYTES, data)) {
            	lIdx = ArrayUtils.indexOf(LF_BYTES, data, HTTPSLASH_BYTES.length);
            	if (lIdx > 0 && data[lIdx - 1] != '\r') {
            		lIdx = ArrayUtils.indexOf(LFLF_BYTES, data, HTTPSLASH_BYTES.length);
            		if (lIdx != -1) {
            			++lIdx;
            			lines = ArrayUtils.split(data, LF_BYTES, 0, lIdx);
            			line = new String(lines.get(0));
            			statusParts = line.split(" ");
            			if (statusParts.length == 2) {
            				sb.setLength(0);
            				sb.append(statusParts[0]);
            				sb.append(' ');
            				sb.append(statusParts[1].substring(0, 3));
            				sb.append(' ');
            				sb.append(statusParts[1].substring(3));
            				lines.set(0, sb.toString().getBytes());
            			}
            			bout.reset();
            			for (int i=0; i<lines.size(); ++i) {
            				bout.write(lines.get(i));
            				bout.write(CRLF_BYTES);
            			}
        				bout.write(CRLF_BYTES);
        				++lIdx;
        				bout.write(data, lIdx, data.length - lIdx);

                        File rightFile = new File("/home/nicl/", "wrong-250-fixed.txt");
                        RandomAccessFile raf = new RandomAccessFile( rightFile, "rw" );
                        raf.write(bout.toByteArray());
                        raf.close();
            		}
            	} else {
            		/*
            		lIdx = ArrayUtils.indexOf(CRLFCRLF_BYTES, data, HTTPSLASH_BYTES.length);
            		if (lIdx != -1) {
            			lIdx += 2;
            			lines = ArrayUtils.split(data, CRLF_BYTES, 0, lIdx);
            		}
            		*/
            		throw new IllegalStateException();
            	}
            } else {
            	/*
          	  fIdx = ArrayUtils.indexOf(HTTPSLASH_BYTES, data,0);
          	  if (fIdx != -1) {
          		  lIdx = ArrayUtils.indexOf(CRLF_BYTES, data, fIdx + 5);
          	  }
          	  */
        		throw new IllegalStateException();
            }
		}
		catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}

}
